/*
	Programmer	: Urban Lindeskog
	Organization	: ProNotion SoftWare Development Group
	Created		: 16/10/94
	Last Change	: 18/03/95

--------

	Alter these variables accordingly.
	ST: is in my case 'RAM:SystemTemporaries'
*/
temptraplog='ST:TodayTrapDoor.log'
tempticklog='ST:TodayTick.log'
BOSSNODE='999:999/999.999'



/*
**	We are wearing sunglasses,
**	...
**
*/
true=1
false=0

OPTIONS RESULTS
OPTIONS FAILAT 15
if ~show('l','rexxsupport.library') then do
	addlib('rexxsupport.library',0,-30,0)
end

/* Kill off any serial port blockers
*/
if show('p','TERM') then do
	address TERM;QUIT FORCE
	address command
	call delay(100)
end

/* Start up TrapDoor if not running
*/
if ~Show('P','TRAPDOOR') then do
	address LOGSERVER 'LOG GROUP "Poll Control" "Starting TrapDoor"'
	address COMMAND
	'run >NIL: <NIL: TrapDoor'
	'waitforport TRAPDOOR'
end


/*
**
**	Poll the boss.
**
**
*/
if ARG()==0 then do
	address LOGSERVER 'LOG GROUP "Poll Control" "Polling the boss."'
	address 'TRAPDOOR'
	'call 'BOSSNODE''
	end
else do
	address LOGSERVER 'LOG GROUP "Poll Control" "Polling 'ARG(1)'"'
	address 'TRAPDOOR'
	'call 'ARG(1)''
	end

	done=false
	call_done=false

	result=IDLE
	do while result==IDLE
		call delay(50)
		address 'TRAPDOOR' '@status S'
	end

	do while ~call_done
		address 'TRAPDOOR' '@status S'

		if result==IDLE then call_done=true

		if exists(temptraplog) then do
			address COMMAND
			'move "'temptraplog'" st:temptrap'

			if open(log,'st:temptrap') then do
				do while ~eof(Log)
					instring = readln(Log)

					if 0==find(instring,'Calling') then do
						if 0==find(instring,'Call failed') then do
							if instring~='' then do
								tempchar=left(instring, 1)
								if tempchar=='~' then address LOGSERVER 'LOG GROUP "Poll Control" "'substr(instring,23)'"'
								if tempchar=='|' then address LOGSERVER 'LOG GROUP "Poll Control" "'substr(instring,23)'"'
								end
							if 0<find(instring,'Call successful') then done=true
						end
					end
				end
				call close(log)
			end

			address COMMAND 'delete >NIL: st:temptrap'
		end
		if ~done | ~call_done then call delay(50)
	end

address LOGSERVER 'LOG GROUP "Poll Control" "Polling Done."'
address WATCHOUT 'RESET'


/*
**
**	Incoming File Processing
**
**
*/
address COMMAND
'FTick <NIL: >NIL:'

if open(Log, tempticklog , 'r') then do
	address LOGSERVER

	'LOG GROUP "Incoming files" "AutoPoll: You have received some files!"'

	do while ~eof(Log)
		instring = readln(Log)
		if 0 < find(instring, 'Received') then do
			filename=substr(instring,34)
			Tog=2
		end
		if Tog==1 then do
			'LOG GROUP "Incoming files" "'left(substr(instring,29), 14)''filename''
			Tog=0
		end
		if(Tog==2) then Tog=1
	end

	call close(Log)
	address COMMAND 'delete >NIL: 'tempticklog
end
exit(0)
