;     ĿĿĿ     ĿĿĿĿ
;          
;        Ŀ   Ŀ  ĿĿ     Ŀ   Ŀ   Ŀ   Ŀ
;                      Ŀ         Ŀ     
;                                         
;                                  v0.39
;
; Ŀ
;  IncludeSysop       Whether to include the Sysop in the output, or not   
;  IncludeHidden      Include users marked as hidden in the output         
;  UseHandles         Use user-handles instead of their real names         
;  Ascii              Produce an ASCII output file                         
;  Ansi               Produce an ANSi output file                          
;  Colour             Use colour or mono-chrome on local display           
;  BirthdayCount      The number of days to include for Upcoming Birthdays 
;   
;  Valid settings for the above opions are: Yes, No, On, Off, True, False   
;   
;  All of the Colour options must be followed by valid colour names or      
;  numbers (There is a full list of names and numbers below)                
;   
;  The options can be in any order, and you can exclude any, to use the     
;  internal defaults...                                                     
; 
;
IncludeSysop        No
IncludeHidden       Yes
UseHandles          No
Ascii               Yes
Ansi                Yes
Colour              On
BirthdayCount       7
;
TitleColour         Yellow
BorderColour        White
UsernameColour      LightGreen
ValueColour         Yellow
GraphDescColour     LightGreen
GraphCountColour    Yellow
GraphBarColour      LightRed
GraphPCentColour    LightGreen
BDayNameColour      LightGreen
BDayAgeColour       White
BDayDOBColour       LightMagenta
;
;  Available Colours ͻ
;   0  Black      1  Blue           2  Green        3  Cyan      
;   4  Red        5  Magenta        6  Brown        7  LightGray 
;   8  DarkGray   9  LightBlue     10  LightGreen  11  LightCyan 
;  12  LightRed  13  LightMagenta  14  Yellow      15  White     
; ͼ
;
; Ŀ
;  The following options allow you to change the filename or disable       
;  specific bulletins that are generated. To disable a bulletin just put   
;  one of 'No, False, Off' after option name (must have a space separating 
;  them), any thing else will be considered a filename..                   
; 
;
ASC_Callers         TOP_CALL.ASC
ANS_Callers         TOP_CALL.ANS
ASC_Download_File   TOP_DL.ASC
ANS_Download_File   TOP_DL.ANS
ASC_Download_KB     TOP_DLK.ASC
ANS_Download_KB     TOP_DLK.ANS
ASC_LongAgo         TOP_AGO.ASC
ANS_LongAgo         TOP_AGO.ANS
ASC_Message         TOP_MESS.ASC
ANS_Message         TOP_MESS.ANS
ASC_TimesCalled     TOP_TIME.ASC
ANS_TimesCalled     TOP_TIME.ANS
ASC_UpLoad_File     TOP_UL.ASC
ANS_UpLoad_File     TOP_UL.ANS
ASC_UpLoad_KB       TOP_ULK.ASC
ANS_UpLoad_KB       TOP_ULK.ANS
ASC_UserAges        TOP_AGE.ASC
ANS_UserAges        TOP_AGE.ANS
ASC_SecLevels       TOP_SEC.ASC
ANS_SecLevels       TOP_SEC.ANS
ASC_MaleFemale      TOP_GEN.ASC
ANS_MaleFemale      TOP_GEN.ANS
ASC_Settings        TOP_SET.ASC
ANS_Settings        TOP_SET.ANS
ASC_Birthdays       TOP_BDAY.ASC
ANS_Birthdays       TOP_BDAY.ANS
ASC_MsgBase         TOP_MSGB.ASC
ANS_MsgBase         TOP_MSGB.ANS
